
/*  A Bison parser, made from parse.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	CLASS	257
#define	FROM	258
#define	CONST	259
#define	VOID	260
#define	STRUCT	261
#define	UNION	262
#define	ENUM	263
#define	THREEDOTS	264
#define	SIGNED	265
#define	UNSIGNED	266
#define	LONG	267
#define	SHORT	268
#define	INT	269
#define	FLOAT	270
#define	DOUBLE	271
#define	CHAR	272
#define	ONERROR	273
#define	TOKEN	274
#define	NUMBER	275
#define	TYPETOKEN	276
#define	ARRAY_DIM	277
#define	CCODE	278
#define	HCODE	279
#define	PUBLIC	280
#define	PRIVATE	281
#define	ARGUMENT	282
#define	VIRTUAL	283
#define	SIGNAL	284
#define	OVERRIDE	285

#line 21 "parse.y"


#include "config.h"
#include <glib.h>
#include <stdio.h>
#include <string.h>

#include "tree.h"
#include "main.h"

#define _(x) (x)
	
extern char *filename;
	
GList *nodes = NULL;

static GList *class_nodes = NULL;
Node *class = NULL;

static GList *typestack = NULL;
static int stars = 0;
static GList *funcargs = NULL;
static GList *checks = NULL;
static int has_self = FALSE;
static int vararg = FALSE;

static GList *gtktypes = NULL;

void free(void *ptr);
int yylex(void);

extern int ccode_line;
extern int line_no;

extern char *yytext;

static void
yyerror(char *str)
{
	char *out=NULL;
	char *p;
	
	if(strcmp(yytext,"\n")==0) {
		out=g_strconcat("Error: ",str," before newline",NULL);
	} else if(yytext[0]=='\0') {
		out=g_strconcat("Error: ",str," at end of input",NULL);
	} else {
		char *tmp = g_strdup(yytext);
		while((p=strchr(tmp,'\n')))
			*p='.';

		out=g_strconcat("Error: ",str," before '",tmp,"'",NULL);
		g_free(tmp);
	}

	fprintf(stderr,"%s:%d: %s\n",filename,line_no,out);
	g_free(out);
	
	exit(1);
}

static void
push_variable(char *name, int scope, int line_no, char *postfix)
{
	Node *var;
	Type *type = typestack->data;
	typestack = g_list_remove(typestack,typestack->data);

	type->postfix = postfix;
	
	var = new_variable(scope,type,name,line_no);
	class_nodes = g_list_append(class_nodes, var);
}

static void
push_function(int scope, char *oid, char *id, char *onerror,
	      GString *cbuf,int line_no, int ccode_line, int vararg)
{
	Node *node;
	Type *type;
       
	if(scope!=INIT_METHOD && scope!=CLASS_INIT_METHOD) {
		type = typestack->data;
		typestack = g_list_remove(typestack,typestack->data);
	} else {
		type = (Type *)new_type(0,g_strdup("void"),NULL);
	}
	
	/* a complicated and ugly test to figure out if we have
	   the wrong number of types for a signal */
	if((scope == SIGNAL_FIRST_METHOD ||
	    scope == SIGNAL_LAST_METHOD ||
	    scope == PRIVATE_SIGNAL_FIRST_METHOD ||
	    scope == PRIVATE_SIGNAL_LAST_METHOD) &&
	   g_list_length(gtktypes) != g_list_length(funcargs) &&
	   !(g_list_length(funcargs) == 1 &&
	     g_list_length(gtktypes) == 2 &&
	     strcmp(gtktypes->next->data,"NONE")==0)) {
		print_error(TRUE, _("The number of GTK arguments and "
				    "function arguments for a signal "
				    "don't seem to match"),line_no);
	}
	node = new_method(scope,type,oid,gtktypes,id,funcargs,
			  onerror,cbuf,line_no,ccode_line,vararg);
	gtktypes = NULL;
	funcargs = NULL;

	class_nodes = g_list_append(class_nodes, node);
}

static void
push_funcarg(char *name, char *postfix)
{
	Node *node;
	Type *type = typestack->data;
	typestack = g_list_remove(typestack,typestack->data);

	type->postfix = postfix;
	
	node = new_funcarg(type,name,checks);
	checks = NULL;
	
	funcargs = g_list_append(funcargs, node);
}

static void
push_init_arg(char *name, int is_class)
{
	Node *node;
	Node *type;
	char *tn;
	
	if(is_class)
		tn = g_strconcat(((Class *)class)->otype,":Class",NULL);
	else
		tn = g_strdup(((Class *)class)->otype);

	type = new_type(1,tn,NULL);
	node = new_funcarg((Type *)type,name,NULL);
	funcargs = g_list_prepend(funcargs, node);
}

static void
push_self(char *id)
{
	Node *node;
	Node *type;
	GList *ch = NULL;
	type = new_type(1,g_strdup(((Class *)class)->otype),NULL);
	ch = g_list_append(ch,new_check(NULL_CHECK,NULL));
	ch = g_list_append(ch,new_check(TYPE_CHECK,NULL));
	node = new_funcarg((Type *)type,id,ch);
	funcargs = g_list_prepend(funcargs, node);
}


#line 178 "parse.y"
typedef union {
	char *id;
	GString *cbuf;
	GList *list;
	int line;
	int sigtype;
} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		216
#define	YYFLAG		-32768
#define	YYNTBASE	46

#define YYTRANSLATE(x) ((unsigned)(x) <= 285 ? yytranslate[x] : 75)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    44,     2,     2,     2,     2,     2,     2,    35,
    36,    38,     2,    39,    45,     2,     2,     2,    41,     2,
     2,     2,     2,     2,     2,     2,     2,     2,    34,    43,
    40,    42,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    32,    37,    33,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     4,     7,    10,    12,    15,    18,    20,    22,    27,
    31,    36,    39,    42,    45,    47,    49,    51,    56,    62,
    67,    73,    85,    94,    98,    99,   103,   105,   107,   110,
   112,   115,   118,   121,   123,   126,   129,   131,   133,   135,
   137,   140,   142,   144,   147,   149,   152,   154,   156,   158,
   160,   162,   165,   167,   168,   170,   174,   178,   181,   184,
   188,   192,   195,   197,   202,   206,   208,   211,   213,   223,
   233,   243,   256,   266,   276,   282,   285,   289,   292,   293,
   295,   297,   301,   303,   307,   309,   313,   315,   318,   322,
   329,   337,   340,   342,   344,   347,   350,   354,   358,   362,
   366,   368,   371
};

static const short yyrhs[] = {    47,
    48,    47,     0,    48,    47,     0,    47,    48,     0,    48,
     0,    47,    24,     0,    47,    25,     0,    24,     0,    25,
     0,    49,    32,    50,    33,     0,    49,    32,    33,     0,
     3,    22,     4,    22,     0,    50,    66,     0,    50,    51,
     0,    50,    52,     0,    66,     0,    51,     0,    52,     0,
    26,    55,    20,    34,     0,    26,    55,    20,    23,    34,
     0,    27,    55,    20,    34,     0,    27,    55,    20,    23,
    34,     0,    28,    53,    20,    20,    20,    32,    24,    20,
    32,    24,    34,     0,    28,    53,    20,    20,    20,    32,
    24,    34,     0,    35,    54,    36,     0,     0,    20,    37,
    54,     0,    20,     0,    56,     0,     5,    56,     0,    57,
     0,    57,    60,     0,    12,    58,     0,    11,    58,     0,
    58,     0,    12,    18,     0,    11,    18,     0,    18,     0,
    17,     0,    16,     0,    20,     0,    59,    20,     0,    22,
     0,     6,     0,    13,    15,     0,    13,     0,    14,    15,
     0,    14,     0,    15,     0,     9,     0,     8,     0,     7,
     0,    38,    60,     0,    38,     0,     0,    26,     0,    27,
    20,    63,     0,    20,    27,    63,     0,    27,    63,     0,
    20,    63,     0,    26,    20,    63,     0,    20,    26,    63,
     0,    26,    63,     0,    63,     0,    20,    35,    64,    36,
     0,    64,    39,    20,     0,    20,     0,    32,    24,     0,
    34,     0,    30,    62,    55,    20,    35,    68,    36,    67,
    65,     0,    29,    27,    55,    20,    35,    68,    36,    67,
    65,     0,    29,    61,    55,    20,    35,    68,    36,    67,
    65,     0,    31,    35,    22,    36,    55,    20,    35,    68,
    36,    67,    32,    24,     0,    26,    55,    20,    35,    68,
    36,    67,    32,    24,     0,    27,    55,    20,    35,    68,
    36,    67,    32,    24,     0,    20,    35,    20,    36,    65,
     0,    19,    74,     0,    19,    32,    24,     0,    40,    41,
     0,     0,     6,     0,    20,     0,    20,    39,    69,     0,
    69,     0,    70,    39,    10,     0,    70,     0,    70,    39,
    71,     0,    71,     0,    55,    20,     0,    55,    20,    23,
     0,    55,    20,    35,    20,    72,    36,     0,    55,    20,
    23,    35,    20,    72,    36,     0,    72,    73,     0,    73,
     0,    20,     0,    42,    74,     0,    43,    74,     0,    42,
    40,    74,     0,    43,    40,    74,     0,    40,    40,    74,
     0,    44,    40,    74,     0,    21,     0,    45,    21,     0,
    20,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   197,   198,   199,   200,   203,   207,   211,   215,   221,   226,
   233,   238,   239,   240,   241,   242,   243,   246,   249,   252,
   255,   259,   288,   314,   315,   318,   321,   327,   328,   336,
   340,   347,   350,   353,   356,   359,   362,   365,   368,   371,
   374,   378,   381,   386,   389,   392,   395,   398,   403,   406,
   409,   414,   415,   418,   419,   422,   434,   446,   449,   461,
   473,   485,   488,   493,   498,   501,   506,   507,   511,   521,
   531,   541,   547,   552,   557,   578,   579,   583,   584,   587,
   588,   599,   609,   612,   613,   616,   617,   620,   623,   626,
   634,   644,   645,   648,   661,   665,   669,   673,   677,   681,
   687,   688,   692
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","CLASS",
"FROM","CONST","VOID","STRUCT","UNION","ENUM","THREEDOTS","SIGNED","UNSIGNED",
"LONG","SHORT","INT","FLOAT","DOUBLE","CHAR","ONERROR","TOKEN","NUMBER","TYPETOKEN",
"ARRAY_DIM","CCODE","HCODE","PUBLIC","PRIVATE","ARGUMENT","VIRTUAL","SIGNAL",
"OVERRIDE","'{'","'}'","';'","'('","')'","'|'","'*'","','","'='","'1'","'>'",
"'<'","'!'","'-'","prog","ccodes","class","classdec","classcode","variable",
"argument","argflags","flaglist","type","type1","type2","integer","tspecifier",
"stars","optpublic","fullsigtype","sigtype","tokenlist","codenocode","method",
"onerror","funcargs","arglist","arglist1","arg","checklist","check","numtok", NULL
};
#endif

static const short yyr1[] = {     0,
    46,    46,    46,    46,    47,    47,    47,    47,    48,    48,
    49,    50,    50,    50,    50,    50,    50,    51,    51,    51,
    51,    52,    52,    53,    53,    54,    54,    55,    55,    56,
    56,    57,    57,    57,    57,    57,    57,    57,    57,    57,
    57,    57,    57,    58,    58,    58,    58,    58,    59,    59,
    59,    60,    60,    61,    61,    62,    62,    62,    62,    62,
    62,    62,    62,    63,    64,    64,    65,    65,    66,    66,
    66,    66,    66,    66,    66,    67,    67,    67,    67,    68,
    68,    68,    68,    69,    69,    70,    70,    71,    71,    71,
    71,    72,    72,    73,    73,    73,    73,    73,    73,    73,
    74,    74,    74
};

static const short yyr2[] = {     0,
     3,     2,     2,     1,     2,     2,     1,     1,     4,     3,
     4,     2,     2,     2,     1,     1,     1,     4,     5,     4,
     5,    11,     8,     3,     0,     3,     1,     1,     2,     1,
     2,     2,     2,     1,     2,     2,     1,     1,     1,     1,
     2,     1,     1,     2,     1,     2,     1,     1,     1,     1,
     1,     2,     1,     0,     1,     3,     3,     2,     2,     3,
     3,     2,     1,     4,     3,     1,     2,     1,     9,     9,
     9,    12,     9,     9,     5,     2,     3,     2,     0,     1,
     1,     3,     1,     3,     1,     3,     1,     2,     3,     6,
     7,     2,     1,     1,     2,     2,     3,     3,     3,     3,
     1,     2,     1
};

static const short yydefact[] = {     0,
     0,     7,     8,     0,     4,     0,     0,     5,     6,     3,
     2,     0,     0,     1,     0,     0,     0,    25,    54,     0,
     0,    10,     0,    16,    17,    15,    11,     0,     0,    43,
    51,    50,    49,     0,     0,    45,    47,    48,    39,    38,
    37,    40,    42,     0,    28,    30,    34,     0,     0,     0,
     0,    55,     0,     0,     0,     0,     0,     0,    63,     0,
     9,    13,    14,    12,     0,    29,    36,    33,    35,    32,
    44,    46,     0,    53,    31,    41,     0,    27,     0,     0,
     0,     0,     0,     0,     0,     0,    59,     0,    62,     0,
    58,     0,     0,     0,     0,    18,     0,    52,     0,    20,
     0,     0,    24,     0,     0,     0,    61,    57,    66,     0,
    60,    56,     0,     0,     0,    68,    75,    19,    43,    40,
     0,     0,    83,    85,    87,    21,     0,    26,     0,     0,
     0,    64,     0,     0,     0,    67,     0,    88,    79,     0,
    79,     0,     0,     0,    65,     0,     0,    82,    89,     0,
     0,     0,     0,    84,    86,     0,     0,    79,    79,    79,
     0,     0,     0,   103,   101,     0,     0,    76,    78,     0,
     0,     0,    23,     0,     0,     0,     0,     0,    94,     0,
     0,     0,     0,     0,    93,    77,   102,    73,    74,     0,
    70,    71,    69,    79,     0,     0,     0,    95,     0,    96,
     0,    90,    92,     0,     0,    91,    99,    97,    98,   100,
    22,     0,    72,     0,     0,     0
};

static const short yydefgoto[] = {   214,
     4,     5,     6,    23,    24,    25,    51,    79,   121,    45,
    46,    47,    48,    75,    54,    58,    59,   110,   117,    26,
   153,   122,   123,   124,   125,   184,   185,   168
};

static const short yypact[] = {    43,
     1,-32768,-32768,    56,    28,    39,    72,-32768,-32768,    28,
   177,   152,    69,   177,    61,   118,   118,    68,   181,    66,
    84,-32768,   164,-32768,-32768,-32768,-32768,    81,   153,-32768,
-32768,-32768,-32768,   185,   191,   106,   113,-32768,-32768,-32768,
-32768,-32768,-32768,   117,-32768,   101,-32768,   126,   135,   137,
   143,-32768,   118,   118,    62,   156,   169,   118,-32768,   174,
-32768,-32768,-32768,-32768,   178,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,    13,   101,-32768,-32768,    60,   175,   179,   193,
   196,   197,   183,   199,   199,   200,-32768,    34,-32768,    34,
-32768,   201,   186,    26,   189,-32768,   136,-32768,   190,-32768,
   136,   137,-32768,   205,   192,   194,-32768,-32768,-32768,    51,
-32768,-32768,   195,   118,   202,-32768,-32768,-32768,   198,   138,
   208,   203,-32768,   204,-32768,-32768,   206,-32768,   209,   136,
   136,-32768,   211,   136,   212,-32768,   118,   -19,    -6,   100,
    -6,   213,   210,   214,-32768,   215,   217,-32768,   218,   216,
   -15,   207,   222,-32768,-32768,   223,    -5,    -6,    -6,    -6,
   136,   220,    35,-32768,-32768,   221,   226,-32768,-32768,   225,
   232,   227,-32768,    26,    26,    26,   224,    35,-32768,   228,
   -12,     4,   229,    21,-32768,-32768,-32768,-32768,-32768,   233,
-32768,-32768,-32768,    -6,    30,     6,     6,-32768,     6,-32768,
     6,-32768,-32768,   230,   231,-32768,-32768,-32768,-32768,-32768,
-32768,   234,-32768,   235,   238,-32768
};

static const short yypgoto[] = {-32768,
     9,   240,-32768,-32768,   239,   242,-32768,   131,   -16,   237,
-32768,   176,-32768,   187,-32768,-32768,   -45,-32768,    12,   244,
  -138,   -99,   133,-32768,   132,    93,  -177,   -97
};


#define	YYLAST		272


static const short yytable[] = {    44,
    49,   127,   156,   149,   164,   165,   203,   164,   165,    87,
    89,    91,   151,    11,   172,   150,   166,   203,    14,   174,
   175,   176,     7,   164,   165,   164,   165,   197,   173,   167,
   143,   144,   167,   152,   146,    95,    81,    82,   107,   108,
   179,    92,   111,   199,   112,     1,    96,    97,   167,   179,
   167,     2,     3,    83,   179,   205,   202,   115,     1,   116,
   180,   177,   181,   182,   183,   206,     2,     3,    86,   180,
    12,   181,   182,   183,   180,    13,   181,   182,   183,     8,
     9,    83,    99,   198,   200,    55,   132,    84,    85,   133,
    27,    56,    57,   100,   101,    28,    86,   135,   207,   208,
    65,   209,    50,   210,    29,    30,    31,    32,    33,   154,
    34,    35,    36,    37,    38,    39,    40,    41,    60,    42,
    71,    43,    29,    30,    31,    32,    33,    72,    34,    35,
    36,    37,    38,    39,    40,    41,    73,    42,    74,    43,
    29,   119,    31,    32,    33,    76,    34,    35,    36,    37,
    38,    39,    40,    41,    77,   120,    78,    43,    30,    31,
    32,    33,    80,    34,    35,    36,    37,    38,    39,    40,
    41,    15,    42,   -81,    43,    88,   137,    16,    17,    18,
    19,    20,    21,    15,    22,   191,   192,   193,    90,    16,
    17,    18,    19,    20,    21,    93,    61,    36,    37,    38,
     8,     9,    67,    36,    37,    38,    52,    53,    69,    68,
    70,   102,   104,    94,   103,   105,   106,    86,    83,   109,
   113,   114,   118,   126,   129,   136,   130,   138,   131,   134,
   145,   147,   128,   -80,   215,   163,   157,   216,   139,   178,
   142,   141,   140,    10,   186,   158,   187,   169,   188,   159,
   160,   161,   162,   170,   171,   189,   204,   213,   190,   194,
    98,    62,   212,   211,    63,    66,    64,   196,   201,   148,
   195,   155
};

static const short yycheck[] = {    16,
    17,   101,   141,    23,    20,    21,   184,    20,    21,    55,
    56,    57,    19,     5,    20,    35,    32,   195,    10,   158,
   159,   160,    22,    20,    21,    20,    21,    40,    34,    45,
   130,   131,    45,    40,   134,    23,    53,    54,    84,    85,
    20,    58,    88,    40,    90,     3,    34,    35,    45,    20,
    45,    24,    25,    20,    20,   194,    36,    32,     3,    34,
    40,   161,    42,    43,    44,    36,    24,    25,    35,    40,
    32,    42,    43,    44,    40,     4,    42,    43,    44,    24,
    25,    20,    23,   181,   182,    20,    36,    26,    27,    39,
    22,    26,    27,    34,    35,    35,    35,   114,   196,   197,
    20,   199,    35,   201,     5,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    35,    20,
    15,    22,     5,     6,     7,     8,     9,    15,    11,    12,
    13,    14,    15,    16,    17,    18,    20,    20,    38,    22,
     5,     6,     7,     8,     9,    20,    11,    12,    13,    14,
    15,    16,    17,    18,    20,    20,    20,    22,     6,     7,
     8,     9,    20,    11,    12,    13,    14,    15,    16,    17,
    18,    20,    20,    36,    22,    20,    39,    26,    27,    28,
    29,    30,    31,    20,    33,   174,   175,   176,    20,    26,
    27,    28,    29,    30,    31,    22,    33,    13,    14,    15,
    24,    25,    18,    13,    14,    15,    26,    27,    18,    34,
    35,    37,    20,    36,    36,    20,    20,    35,    20,    20,
    20,    36,    34,    34,    20,    24,    35,    20,    35,    35,
    20,    20,   102,    36,     0,    20,    24,     0,    36,    20,
    32,    36,    39,     4,    24,    36,    21,    41,    24,    36,
    36,    35,    35,    32,    32,    24,    24,    24,    32,    36,
    74,    23,    32,    34,    23,    29,    23,    40,    40,   137,
   178,   140
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 197 "parse.y"
{ ; ;
    break;}
case 2:
#line 198 "parse.y"
{ ; ;
    break;}
case 3:
#line 199 "parse.y"
{ ; ;
    break;}
case 4:
#line 200 "parse.y"
{ ; ;
    break;}
case 5:
#line 203 "parse.y"
{
			Node *node = new_ccode(FALSE,yyvsp[0].cbuf,ccode_line);
			nodes = g_list_append(nodes,node);
					;
    break;}
case 6:
#line 207 "parse.y"
{
			Node *node = new_ccode(TRUE,yyvsp[0].cbuf,ccode_line);
			nodes = g_list_append(nodes,node);
					;
    break;}
case 7:
#line 211 "parse.y"
{
			Node *node = new_ccode(FALSE,yyvsp[0].cbuf,ccode_line);
			nodes = g_list_append(nodes,node);
					;
    break;}
case 8:
#line 215 "parse.y"
{
			Node *node = new_ccode(TRUE,yyvsp[0].cbuf,ccode_line);
			nodes = g_list_append(nodes,node);
					;
    break;}
case 9:
#line 221 "parse.y"
{
			((Class *)class)->nodes = class_nodes;
			class_nodes = NULL;
			nodes = g_list_append(nodes,class);
						;
    break;}
case 10:
#line 226 "parse.y"
{
			((Class *)class)->nodes = NULL;
			class_nodes = NULL;
			nodes = g_list_append(nodes,class);
						;
    break;}
case 11:
#line 233 "parse.y"
{
			class = new_class(yyvsp[-2].id,yyvsp[0].id,NULL);
						;
    break;}
case 12:
#line 238 "parse.y"
{ ; ;
    break;}
case 13:
#line 239 "parse.y"
{ ; ;
    break;}
case 14:
#line 240 "parse.y"
{ ; ;
    break;}
case 15:
#line 241 "parse.y"
{ ; ;
    break;}
case 16:
#line 242 "parse.y"
{ ; ;
    break;}
case 17:
#line 243 "parse.y"
{ ; ;
    break;}
case 18:
#line 246 "parse.y"
{
			push_variable(yyvsp[-1].id,PUBLIC_SCOPE,yyvsp[-3].line,NULL);
						;
    break;}
case 19:
#line 249 "parse.y"
{
			push_variable(yyvsp[-2].id,PUBLIC_SCOPE,yyvsp[-4].line,yyvsp[-1].id);
						;
    break;}
case 20:
#line 252 "parse.y"
{
			push_variable(yyvsp[-1].id,PRIVATE_SCOPE,yyvsp[-3].line,NULL);
						;
    break;}
case 21:
#line 255 "parse.y"
{
			push_variable(yyvsp[-2].id,PRIVATE_SCOPE,yyvsp[-4].line,yyvsp[-1].id);
						 ;
    break;}
case 22:
#line 259 "parse.y"
{
			if(strcmp(yyvsp[-6].id,"get")==0 &&
			   strcmp(yyvsp[-3].id,"set")==0) {
				Node *node;
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-8].id,yyvsp[-9].list,yyvsp[-7].id,
						    yyvsp[-4].cbuf,yyvsp[-5].line,
						    yyvsp[-1].cbuf,yyvsp[-2].line,
						    yyvsp[-10].line);
				class_nodes = g_list_append(class_nodes,node);
			} else if(strcmp(yyvsp[-6].id,"set")==0 &&
				strcmp(yyvsp[-3].id,"get")==0) {
				Node *node;
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-8].id,yyvsp[-9].list,yyvsp[-7].id,
						    yyvsp[-1].cbuf,yyvsp[-2].line,
						    yyvsp[-4].cbuf,yyvsp[-5].line,
						    yyvsp[-10].line);
				class_nodes = g_list_append(class_nodes,node);
			} else {
				g_free(yyvsp[-8].id); g_free(yyvsp[-7].id);
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				g_list_foreach(yyvsp[-9].list,(GFunc)g_free,NULL);
				g_string_free(yyvsp[-1].cbuf,TRUE);
				g_string_free(yyvsp[-4].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 23:
#line 288 "parse.y"
{
			if(strcmp(yyvsp[-3].id,"get")==0) {
				Node *node;
				g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-5].id,yyvsp[-6].list,yyvsp[-4].id,
						    yyvsp[-1].cbuf,yyvsp[-2].line,NULL,0,
						    yyvsp[-7].line);
				class_nodes = g_list_append(class_nodes,node);
			} else if(strcmp(yyvsp[-3].id,"set")==0) {
				Node *node;
				g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-5].id,yyvsp[-6].list,yyvsp[-4].id,
						    NULL,0,yyvsp[-1].cbuf,yyvsp[-2].line,
						    yyvsp[-7].line);
				class_nodes = g_list_append(class_nodes,node);
			} else {
				g_free(yyvsp[-3].id); g_free(yyvsp[-5].id);
				g_free(yyvsp[-4].id);
				g_list_foreach(yyvsp[-6].list,(GFunc)g_free,NULL);
				g_string_free(yyvsp[-1].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 24:
#line 314 "parse.y"
{ yyval.list = yyvsp[-1].list; ;
    break;}
case 25:
#line 315 "parse.y"
{ yyval.list = NULL; ;
    break;}
case 26:
#line 318 "parse.y"
{
			yyval.list = g_list_append(yyvsp[0].list,yyvsp[-2].id);
						;
    break;}
case 27:
#line 321 "parse.y"
{
			yyval.list = g_list_append(NULL,yyvsp[0].id);
						;
    break;}
case 28:
#line 327 "parse.y"
{ ; ;
    break;}
case 29:
#line 328 "parse.y"
{
			Type *type = typestack->data;
			char *oldname = type->name;
			type->name = g_strconcat("const ",oldname,NULL);
			g_free(oldname);
						;
    break;}
case 30:
#line 336 "parse.y"
{
			Node *node = new_type(0,yyvsp[0].id,NULL);
			typestack = g_list_prepend(typestack,node);
						;
    break;}
case 31:
#line 340 "parse.y"
{
			Node *node = new_type(stars,yyvsp[-1].id,NULL);
			stars = 0;
			typestack = g_list_prepend(typestack,node);
						;
    break;}
case 32:
#line 347 "parse.y"
{
			yyval.id = g_strconcat("unsigned ",yyvsp[0].id,NULL);
						;
    break;}
case 33:
#line 350 "parse.y"
{
			yyval.id = g_strconcat("signed ",yyvsp[0].id,NULL);
						;
    break;}
case 34:
#line 353 "parse.y"
{
			yyval.id = g_strdup(yyvsp[0].id);
						;
    break;}
case 35:
#line 356 "parse.y"
{
			yyval.id = g_strdup("unsigned char");
						;
    break;}
case 36:
#line 359 "parse.y"
{
			yyval.id = g_strdup("signed char");
						;
    break;}
case 37:
#line 362 "parse.y"
{
			yyval.id = g_strdup("char");
						;
    break;}
case 38:
#line 365 "parse.y"
{
			yyval.id = g_strdup("double");
						;
    break;}
case 39:
#line 368 "parse.y"
{
			yyval.id = g_strdup("float");
						;
    break;}
case 40:
#line 371 "parse.y"
{
			yyval.id = yyvsp[0].id;
						;
    break;}
case 41:
#line 374 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id,yyvsp[0].id,NULL);
			g_free(yyvsp[0].id);
						;
    break;}
case 42:
#line 378 "parse.y"
{
			yyval.id = yyvsp[0].id;
						;
    break;}
case 43:
#line 381 "parse.y"
{
			yyval.id = g_strdup("void");
						;
    break;}
case 44:
#line 386 "parse.y"
{
			yyval.id = "long int";
						;
    break;}
case 45:
#line 389 "parse.y"
{
			yyval.id = "long";
						;
    break;}
case 46:
#line 392 "parse.y"
{
			yyval.id = "short int";
						;
    break;}
case 47:
#line 395 "parse.y"
{
			yyval.id = "short";
						;
    break;}
case 48:
#line 398 "parse.y"
{
			yyval.id = "int";
						;
    break;}
case 49:
#line 403 "parse.y"
{
			yyval.id = "enum ";
						;
    break;}
case 50:
#line 406 "parse.y"
{
			yyval.id = "union ";
						;
    break;}
case 51:
#line 409 "parse.y"
{
			yyval.id = "struct ";
						;
    break;}
case 52:
#line 414 "parse.y"
{ stars++; ;
    break;}
case 53:
#line 415 "parse.y"
{ stars++; ;
    break;}
case 54:
#line 418 "parse.y"
{ ; ;
    break;}
case 55:
#line 419 "parse.y"
{ ; ;
    break;}
case 56:
#line 422 "parse.y"
{
			if(strcmp(yyvsp[-1].id,"first")==0)
				yyval.sigtype = PRIVATE_SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-1].id,"last")==0)
				yyval.sigtype = PRIVATE_SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-1].id);
				YYERROR;
			}
			g_free(yyvsp[-1].id);
					;
    break;}
case 57:
#line 434 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"first")==0)
				yyval.sigtype = PRIVATE_SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-2].id,"last")==0)
				yyval.sigtype = PRIVATE_SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-2].id);
				YYERROR;
			}
			g_free(yyvsp[-2].id);
					;
    break;}
case 58:
#line 446 "parse.y"
{
			yyval.sigtype = PRIVATE_SIGNAL_LAST_METHOD;
					;
    break;}
case 59:
#line 449 "parse.y"
{
			if(strcmp(yyvsp[-1].id,"first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-1].id,"last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-1].id);
				YYERROR;
			}
			g_free(yyvsp[-1].id);
					;
    break;}
case 60:
#line 461 "parse.y"
{
			if(strcmp(yyvsp[-1].id,"first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-1].id,"last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-1].id);
				YYERROR;
			}
			g_free(yyvsp[-1].id);
					;
    break;}
case 61:
#line 473 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-2].id,"last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-2].id);
				YYERROR;
			}
			g_free(yyvsp[-2].id);
					;
    break;}
case 62:
#line 485 "parse.y"
{
			yyval.sigtype = SIGNAL_LAST_METHOD;
					;
    break;}
case 63:
#line 488 "parse.y"
{
			yyval.sigtype = SIGNAL_LAST_METHOD;
					;
    break;}
case 64:
#line 493 "parse.y"
{
			gtktypes = g_list_prepend(gtktypes,yyvsp[-3].id);
						;
    break;}
case 65:
#line 498 "parse.y"
{
			gtktypes = g_list_append(gtktypes,yyvsp[0].id);
						;
    break;}
case 66:
#line 501 "parse.y"
{ 
			gtktypes = g_list_append(gtktypes,yyvsp[0].id);
       						;
    break;}
case 67:
#line 506 "parse.y"
{ yyval.cbuf=yyvsp[0].cbuf; ;
    break;}
case 68:
#line 507 "parse.y"
{ yyval.cbuf = NULL; ;
    break;}
case 69:
#line 511 "parse.y"
{
			if(!has_self) {
				yyerror(_("signal without 'self' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(yyvsp[-7].sigtype,NULL,
				      yyvsp[-5].id, yyvsp[-1].id, yyvsp[0].cbuf,yyvsp[-8].line,
				      ccode_line,vararg);
									;
    break;}
case 70:
#line 521 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(PRIVATE_VIRTUAL_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[-1].id, yyvsp[0].cbuf,yyvsp[-8].line,
				      ccode_line,vararg);
									;
    break;}
case 71:
#line 531 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(VIRTUAL_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[-1].id, yyvsp[0].cbuf,yyvsp[-8].line,
				      ccode_line,vararg);
									;
    break;}
case 72:
#line 541 "parse.y"
{
			push_function(OVERRIDE_METHOD, yyvsp[-9].id,
				      yyvsp[-6].id, yyvsp[-2].id, yyvsp[0].cbuf,
				      yyvsp[-11].line,yyvsp[-1].line,
				      vararg);
									;
    break;}
case 73:
#line 547 "parse.y"
{
			push_function(PUBLIC_SCOPE, NULL, yyvsp[-6].id,
				      yyvsp[-2].id, yyvsp[0].cbuf,yyvsp[-8].line,yyvsp[-1].line,
				      vararg);
								;
    break;}
case 74:
#line 552 "parse.y"
{
			push_function(PRIVATE_SCOPE, NULL, yyvsp[-6].id,
				      yyvsp[-2].id, yyvsp[0].cbuf,yyvsp[-8].line,yyvsp[-1].line,
				      vararg);
								;
    break;}
case 75:
#line 557 "parse.y"
{
			if(strcmp(yyvsp[-4].id,"init")==0) {
				push_init_arg(yyvsp[-2].id,FALSE);
				push_function(INIT_METHOD, NULL,
					      yyvsp[-4].id, NULL, yyvsp[0].cbuf,yyvsp[-3].line,
					      ccode_line,FALSE);
			} else if(strcmp(yyvsp[-4].id,"class_init")==0) {
				push_init_arg(yyvsp[-2].id,TRUE);
				push_function(CLASS_INIT_METHOD, NULL, 
					      yyvsp[-4].id, NULL, yyvsp[0].cbuf,yyvsp[-3].line,
					      ccode_line,FALSE);
			} else {
				g_free(yyvsp[-4].id);
				g_free(yyvsp[-2].id);
				g_string_free(yyvsp[-2].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 76:
#line 578 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 77:
#line 579 "parse.y"
{
			yyval.id = (yyvsp[0].cbuf)->str;
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 78:
#line 583 "parse.y"
{ ; ;
    break;}
case 79:
#line 584 "parse.y"
{ yyval.id = NULL; ;
    break;}
case 80:
#line 587 "parse.y"
{ vararg = FALSE; has_self = FALSE; ;
    break;}
case 81:
#line 588 "parse.y"
{
			vararg = FALSE;
			has_self = TRUE;
			if(strcmp(yyvsp[0].id,"self")==0)
				push_self(yyvsp[0].id);
			else {
				g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
       					;
    break;}
case 82:
#line 599 "parse.y"
{
			has_self = TRUE;
			if(strcmp(yyvsp[-2].id,"self")==0)
				push_self(yyvsp[-2].id);
			else {
				g_free(yyvsp[-2].id);
				yyerror(_("parse error"));
				YYERROR;
			}
					;
    break;}
case 83:
#line 609 "parse.y"
{ has_self = FALSE; ;
    break;}
case 84:
#line 612 "parse.y"
{ vararg = TRUE; ;
    break;}
case 85:
#line 613 "parse.y"
{ vararg = FALSE; ;
    break;}
case 86:
#line 616 "parse.y"
{ ; ;
    break;}
case 87:
#line 617 "parse.y"
{ ; ;
    break;}
case 88:
#line 620 "parse.y"
{
			push_funcarg(yyvsp[0].id,NULL);
								;
    break;}
case 89:
#line 623 "parse.y"
{
			push_funcarg(yyvsp[-1].id,yyvsp[0].id);
								;
    break;}
case 90:
#line 626 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"check")!=0) {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-2].id);
			push_funcarg(yyvsp[-4].id,NULL);
								;
    break;}
case 91:
#line 634 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"check")!=0) {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-2].id);
			push_funcarg(yyvsp[-5].id,yyvsp[-4].id);
								;
    break;}
case 92:
#line 644 "parse.y"
{ ; ;
    break;}
case 93:
#line 645 "parse.y"
{ ; ;
    break;}
case 94:
#line 648 "parse.y"
{
			if(strcmp(yyvsp[0].id,"type")==0) {
				Node *node = new_check(TYPE_CHECK,NULL);
				checks = g_list_append(checks,node);
			} else if(strcmp(yyvsp[0].id,"null")==0) {
				Node *node = new_check(NULL_CHECK,NULL);
				checks = g_list_append(checks,node);
			} else {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[0].id);
					;
    break;}
case 95:
#line 661 "parse.y"
{
			Node *node = new_check(GT_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 96:
#line 665 "parse.y"
{
			Node *node = new_check(LT_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 97:
#line 669 "parse.y"
{
			Node *node = new_check(GE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 98:
#line 673 "parse.y"
{
			Node *node = new_check(LE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 99:
#line 677 "parse.y"
{
			Node *node = new_check(EQ_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 100:
#line 681 "parse.y"
{
			Node *node = new_check(NE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 101:
#line 687 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 102:
#line 688 "parse.y"
{
			yyval.id = g_strconcat("-",yyvsp[0].id,NULL);
			g_free(yyvsp[0].id);
					;
    break;}
case 103:
#line 692 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 695 "parse.y"

